import { Interval } from './interval';
export type IntervalUnit = 'ms' | 's' | 'm' | 'h' | 'D' | 'W' | 'M' | 'Y';
type _IntervalUnitData = {
    [P in IntervalUnit]: number;
};
export interface IntervalData extends _IntervalUnitData {
    inversed: boolean;
}
export type IntervalUnitRegexMap = {
    [P in IntervalUnit]: RegExp;
};
export type IntervalUnitSecondFactor = {
    [P in IntervalUnit]: number;
};
export type IntervalArg = string | Interval | Partial<IntervalData>;
/**
 * @deprecated
 */
export type IntervalInput = IntervalArg;
export declare const IntervalUnitArray: IntervalUnit[];
export declare const IntervalUnitDescArray: IntervalUnit[];
export declare const IntervalUnitRegexes: IntervalUnitRegexMap;
export declare const IntervalExpressionValidationRegex: RegExp;
export declare const IntervalUnitSecondFactors: IntervalUnitSecondFactor;
export {};
