"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.NoErrorListenerError = exports.RunnerTimeoutError = exports.RunnerAlreadyRunningError = void 0;
class RunnerAlreadyRunningError extends Error {
    runnerName;
    constructor(runnerName) {
        super(`Le runner ${runnerName} est déjà en cours`);
        this.runnerName = runnerName;
    }
}
exports.RunnerAlreadyRunningError = RunnerAlreadyRunningError;
class RunnerTimeoutError extends Error {
    runnerName;
    constructor(runnerName) {
        super(`Le runner ${runnerName} a dépassé le temps`);
        this.runnerName = runnerName;
    }
}
exports.RunnerTimeoutError = RunnerTimeoutError;
class NoErrorListenerError extends Error {
    runnerName;
    constructor(runnerName) {
        super(`Le runner ${runnerName} n'est pas protégé (écouter l'événement error)`);
        this.runnerName = runnerName;
    }
}
exports.NoErrorListenerError = NoErrorListenerError;
